import org.omg.CORBA.*;

// servant must extend DynamicImplementation
class HelloServant extends DynamicImplementation {

    // store the repository ID for the implemented interface
    static String[] myIDs = {"IDL:HelloApp/Hello:1.0"};
    ORB orb;

    // implement an _ids method to return repository ID of interface
    public String[] _ids() {    
        return myIDs;
    }

    // create a reference to the ORB
    HelloServant(ORB orb) {
        this.orb = orb;
    }

    // must implement invoke() for handling requests
    public void invoke(ServerRequest request) {
        try {
            System.out.println("DSI: invoke called, op = "+request.op_name());

            // create an NVList to hold the parameters
            NVList nvlist = orb.create_list(0);

            // need an if statement like this for each method name
            if (request.op_name().equals("printHelloArgs") == true) {

                    // need an Any for each argument
                    Any any1 = orb.create_any();
                    any1.insert_string("");
                    nvlist.add_value("arg1", any1, ARG_IN.value);

                    Any any2 = orb.create_any();
                    any2.insert_string("");
                    nvlist.add_value("arg2", any2, ARG_IN.value);

                    // pass the NVList to the request to get values
                    request.params(nvlist);

                    System.err.println("Argument 1: In value: " + nvlist.item(0).value().extract_string());

                    System.err.println("Argument 2: In value: " + nvlist.item(1).value().extract_string());


                    Any result_any = orb.create_any();
		    result_any.insert_string("\nHello world !!\n");
                    request.result(result_any);
            }
        }
        catch (Exception ex) {
            ex.printStackTrace();
            System.out.println("DSIExample: Exception thrown: " + ex);
        }
    }    
}
